#include <stdio.h>
#include <stdlib.h>
#include <math.h>


main(int argc, char *argv[])
{
    double calcFreq, dsrFreq, nrsFreq, Diff, smlstDiff;
    int   m=1, n=1, p=0,bestM, bestN;
    
    printf("\nPLL Clock Matcher\n"
           "For Matrox MGA Mystique/Mystique 220\n"
           "Integrated RAMDAC\n"
           "All Rights Reserved.\n\n");

    if (argc == 1) {
	printf("Syntax:   CLKMTCH [Freq in MHz] [P Value]\n\n"
	       "if P Value is omitted, zero is used for P.\n");
	return 0;
    }

    if (argc == 3) p = atoi(argv[2]);

    if (!(p==0 || p==1 || p==3 || p==7)) {
	printf("\nInvalid P value.  P = 0,1,3,7\n");
	return 0;
    }

    dsrFreq  = atof(argv[1]);
    calcFreq = (((double) n + 1.0) / (((double) m + 1.0)
	       * ((double) p + 1.0))) * 14.31818;
    Diff     = fabs(dsrFreq - calcFreq);
    smlstDiff = Diff;
    bestM = m;
    bestN = n;

    for (m=1; m<32; m++) {
	for (n=1; n<128; n++) {
	    calcFreq = (((double) n + 1.0) / (((double) m + 1.0)
		       * ((double) p + 1.0))) * 14.31818;
	    Diff     = fabs(dsrFreq - calcFreq);
	    if (Diff <= smlstDiff) {
		smlstDiff = Diff;
		nrsFreq = calcFreq;
		bestM = m;
		bestN = n;
	    }
	}
    }
    printf("Nearest Freq = %.2f MHz  (M=%d, N=%d, P=%d)\n",
	    nrsFreq, bestM, bestN,p);

    return 0;
}
