;*********************************************************
;      Matrox MGA Myst/Myst220/G100/G200
;      GCLK/MCLK Programmer
;      By Liew Khong Jye.
;
;      Special thanks to Royce Liao, the author of MCLK,
;      for providing chip information.
;*********************************************************


.286c
.model tiny

MATROX_MYSTIQUE equ     051A102Bh
MGA_G100_PCI    equ     1000102Bh
MGA_G100_AGP    equ     1001102Bh
MGA_G200_PCI    equ     0520102Bh
MGA_G200_AGP    equ     0521102Bh

MATROX          equ     102Bh   ; PCI Vendor
MYSTIQUE        equ     051Ah   ; PCI Device
G100_PCI        equ     1000h
G100_AGP        equ     1001h
G200_PCI        equ     0520h
G200_AGP        equ     0521h

PCICHK          equ     0B101h
FINDDEV         equ     0B102h
RCONF_B         equ     0B108h
RCONF_W         equ     0B109h
WCONF_B         equ     0B10Bh
WCONF_W         equ     0B10Ch
WCONF_D         equ     0B10Dh


CONFADD		equ	 0CF8h	; PCI Configuration Space Mechanism 1
CONFDATA	equ	 0CFCh

DEVID           equ       00h
MGA_INDEX1      equ       44h
MGA_INDEX2      equ       46h
MGA_DATA1       equ       48h
MGA_DATA2       equ       4Ah
MGA_OPTION      equ       40h

PALWTADD        equ     3C00h
X_DATAREG       equ     3C08h
MACCESS         equ     1C04h	; Write-Only
MCTLWTST        equ     1C08h	; Write-Only
SEQ             equ     1FC4h

CLKMODE         equ       01h
XMULCTRL        equ       19h
SYSPLL_M        equ       2Ch
SYSPLL_N        equ       2Dh
SYSPLL_P        equ       2Eh
SYSPLLSTAT      equ       2Fh


prog segment
assume cs:prog, ds:prog, ss:prog
org 100h

start:          mov     ah, 09
                lea     dx, [headerMsg]
                int     21h

                mov     ax, 3d00h
                lea     dx, [INIFile]
                int     21h
                jb      NoINIInfo

                mov     bx, ax
                mov     ah, 3fh
                lea     dx, [workBuffer]
                mov     cx, 9
                int     21h
                jb      NoINIInfo
                mov     ah, 3eh
                int     21h

                lea     si, [workBuffer]
                mov     cx, 7

Uppercase:      mov     al, [si]
                and     al, 0DFh
                mov     [si], al
                inc     si
                loop    Uppercase

                lea     di, [INIString]
                lea     si, [workBuffer]
                mov     cx, 8
                cld
                repz    cmpsb
                jnz     NoINIInfo
                mov     cx, 10
                call    AscToInt

                .IF     ( al == 0 || al == 1)
                mov     PCIBIOS, al
                .ENDIF


NoINIInfo:      .IF     (PCIBIOS == 1)
                lea     dx, [PCIBIOSCall]
                .ENDIF

                .IF      (PCIBIOS == 0)
                lea     dx, [PCIMech1]
                .ENDIF

                mov     ah, 09h
                int     21h
                lea     dx, [ChipInfo]
                mov     ah, 09h
                int     21h



.IF     (PCIBIOS == 0)
.386c
                mov     ecx, 0ffffh

nextDev:        mov     eax, ecx
                shl     eax, 8
                mov     edx, DEVID
                shr     edx, 2
                shl     edx, 2
                add     eax, edx
                or      eax, 80000000h
                mov     edx, CONFADD
                out     dx, eax
                jmp     $+2
                jmp     $+2

                mov     edx, CONFDATA
                in      eax, dx

                cmp     eax, MATROX_MYSTIQUE
                jz      MystFound
                cmp     eax, MGA_G100_PCI
                jz      MystFound
                cmp     eax, MGA_G100_AGP
                jz      MystFound
                cmp     eax, MGA_G200_PCI
                jz      MystFound
                cmp     eax, MGA_G200_AGP
                jz      MystFound

                loop    nextDev
                lea     dx, Err2NoMGA
                jmp     Error

MystFound:      mov     devFuncBus, ecx

                .IF     (eax == MATROX_MYSTIQUE)
                        lea     dx, [MystPCI]

                .ELSEIF (eax == MGA_G100_PCI)
                        lea     dx, [G100PCI]

                .ELSEIF (eax == MGA_G100_AGP)
                        lea     dx, [G100AGP]

                .ELSEIF (eax == MGA_G200_PCI)
                        lea     dx, [G200PCI]

                .ELSEIF (eax == MGA_G200_AGP)
                        lea     dx, [G200AGP]
                .ENDIF

.ENDIF

.286c

.IF	(PCIBIOS == 1)
                mov     ax, PCICHK              ; check for PCI System
                int     1ah
                lea     dx, Err1NoPCI
                or      ah, ah
                jnz     Error

                mov     ax, FINDDEV             ; check for Matrox Mystique
                mov     cx, MYSTIQUE
                mov     dx, MATROX
                xor     si, si
                int     1ah
                lea     dx, [MystPCI]
                jnb     MGAFound

                mov     ax, FINDDEV
                mov     cx, G100_PCI
                mov     dx, MATROX
                xor     si, si
                int     1ah
                lea     dx, [G100PCI]
                jnb     MGAFound

                mov     ax, FINDDEV
                mov     cx, G100_AGP
                mov     dx, MATROX
                xor     si, si
                int     1ah
                lea     dx, [G100AGP]
                jnb     MGAFound

                mov     ax, FINDDEV
                mov     cx, G200_PCI
                mov     dx, MATROX
                xor     si, si
                int     1ah
                lea     dx, [G200PCI]
                jnb     MGAFound

                mov     ax, FINDDEV
                mov     cx, G200_AGP
                mov     dx, MATROX
                xor     si, si
                int     1ah
                lea     dx, [G200AGP]
                jnb     MGAFound

                lea     dx, Err2NoMGA
                jmp     Error


MGAFound:
                mov     word ptr [devFuncBus], bx       ; Save Mystique Bus number,
                                                        ; function/device number.
.ENDIF
                mov     ah, 09
                int     21h

                call    GetInfo

                mov     di, 81h
                mov     al, 0dh
                mov     cx, 0ffffh
                cld
                repnz   scasb
                not     cx

                mov     di, 81h

                .WHILE 1
                mov     al, '/'
                repnz   scasb
                .BREAK  .IF (cx == 0)
                mov     si, di
                lodsb
                inc     di
                dec     cx

                .IF     (al == '?')
                mov	noParam, 0
                mov     ah, 09h
                lea     dx, [Hlp]
                int     21h
		mov	ah, 0
		int	16h
                mov     ah, 09h
                lea     dx, [Hlp3]
                int     21h
                .BREAK	
                .ENDIF

; ------------------------------------------- SysPLL: M N P
                .IF     (al == '1')
                mov     noParam, 0
                mov     resCMD, 1
                push    cx
                push    di
                mov     al, 20h
                repz    scasb
                dec     di
                push    di
                repnz   scasb
                dec     di
                mov     byte ptr es:[di], 0
                pop     si
                mov     cx, 0ah
                call    AscToInt
                push    ax

                inc     di
                mov     al, 20h
                repz    scasb
                dec     di
                push    di
                repnz   scasb
                dec     di
                mov     byte ptr es:[di], 0
                pop     si
                mov     cx, 0ah
                call    AscToInt
                push    ax

                inc     di
                mov     al, 20h
                repz    scasb
                dec     di
                push    di
                mov     si, di
                .REPEAT
                lodsb
                .UNTIL (al == 20h || al == 0Dh)
                dec     si
                mov     byte ptr es:[si], 0
                pop     si
                mov     cx, 0ah
                call    AscToInt
                push    ax
                call    SetSysPLLVal
                add     sp, 6
                .ENDIF

;------------------------------------------- MemWait: CSLan RCDelay RMact
                .IF     (al == '2')
                mov     noParam, 0
                mov     resCmd, 1
                push    cx
                push    di
                mov     al, 20h
                repz    scasb
                dec     di
                push    di
                repnz   scasb
                dec     di
                mov     byte ptr es:[di], 0
                pop     si
                mov     cx, 0ah
                call    AscToInt
                push    ax

                inc     di
                mov     al, 20h
                repz    scasb
                dec     di
                push    di
                repnz   scasb
                dec     di
                mov     byte ptr es:[di], 0
                pop     si
                mov     cx, 0ah
                call    AscToInt
                push    ax

                inc     di
                mov     al, 20h
                repz    scasb
                dec     di
                push    di
                mov     si, di
                .REPEAT
                lodsb
                .UNTIL (al == 20h || al == 0Dh)
                dec     si
                mov     byte ptr es:[si], 0
                pop     si
                mov     cx, 0ah
                call    AscToInt
                push    ax
                call    WriteMemWait
                add     sp, 6
                .ENDIF

;---------------------------------------------------clkDiv: GCLK MCLK
                .IF     ( al == '3')
                mov     noParam, 0
                mov     resCmd, 1
                push    cx
                push    di
                mov     al, 20h
                repz    scasb
                dec     di
                push    di
                repnz   scasb
                dec     di
                mov     byte ptr es:[di], 0
                pop     si
                mov     cx, 0ah
                call    AscToInt
                push    ax

                inc     di
                mov     al, 20h
                repz    scasb
                dec     di
                push    di
                mov     si, di
                .REPEAT
                lodsb
                .UNTIL (al == 20h || al == 0Dh)
                dec     si
                mov     byte ptr es:[si], 0
                pop     si
                mov     cx, 0ah
                call    AscToInt
                push    ax

                mov     al, 1
                call    RWClkDiv
                add     sp, 4
                .ENDIF
;------------------------------------------------------ rcntx, rcnty
                .IF     ( al == '4')
                mov     noParam, 0
                mov     resCmd, 1
                push    cx
                push    di
                mov     al, 20h
                repz    scasb
                dec     di
                push    di
                repnz   scasb
                dec     di
                mov     byte ptr es:[di], 0
                pop     si
                mov     cx, 0ah
                call    AscToInt
                push    ax

                inc     di
                mov     al, 20h
                repz    scasb
                dec     di
                push    di
                mov     si, di
                .REPEAT
                lodsb
                .UNTIL (al == 20h || al == 0Dh)
                dec     si
                mov     byte ptr es:[si], 0
                pop     si
                mov     cx, 0ah
                call    AscToInt
                push    ax

                mov     al, 1
                call    RWRfCTR
                add     sp, 4
                .ENDIF

;------------------------------------------------------------------
                .IF     (resCmd == 1)
                pop     di
                pop     cx
                mov     resCmd, 0
                .ENDIF
                .BREAK  .IF     ( ax == 0ffffh )
                .ENDW

                .IF     (noParam == 1)
                mov     ah, 09
                lea     dx, [ShowMsg]
                int     21h
                .ENDIF

                .IF     ( ax == 0ffffh )
                mov     ah, 09h
                lea     dx, [Err3Param]
                int     21h
                .ENDIF

                
EndProg:        mov     ax, 4c00h
                int     21h

Error:          mov     ah, 09h
                int     21h
                jmp     EndProg

GetInfo         proc    near

                push    ax
                push    bx
                push    cx
                push    dx
                push    di
                push    si

                xor     al, al
                call    RWClkDiv
                mov     mclkDiv, ah
                mov     gclkDiv, al

                .IF     (al == 0)
                mov     gdivASC, '3'
                .ELSE
                mov     gdivASC, '1'
                .ENDIF
                                
                .IF     (ah == 0)
                mov     mdivASC, '2'
                .ELSE
                mov     mdivASC, '1'
                .ENDIF

                push    SYSPLL_M
                xor     al, al
                call    RWSysPLLVal
                add     sp, 2
                mov     m_Val, al

                push    SYSPLL_N
                xor     al, al
                call    RWSysPLLVal
                add     sp, 2
                mov     n_Val, al

                push    SYSPLL_P
                xor     al, al
                call    RWSysPLLVal
                add     sp, 2
                push    ax
                and     al, 00000111b
                mov     p_Val, al
                pop     ax
                shr     ax, 3
                and     al, 00000011b
                mov     s_Val, al

                xor     ax, ax
                mov     al, m_Val
                lea     si, M_ASC
                mov     cx, 0ah
                call    IntToAsc

                xor     ax, ax
                mov     al, n_Val
                lea     si, N_ASC
                mov     cx, 0ah
                call    IntToAsc

                xor     ax, ax
                mov     al, p_Val
                lea     si, P_ASC
                mov     cx, 0ah
                call    IntToAsc


                xor     ax, ax
                mov     al, m_Val
                push    ax
                mov     al, n_Val
                push    ax
                mov     al, p_Val
                push    ax
                call    CalcFreq
                add     sp, 6

                lea     si, FreqASCq
                call    IntToAsc
                mov     ax, dx
                lea     si, FreqASCr
                call    IntToAsc

                xor     al, al
                call    RWRfCTR
                push    ax
                and     al, 00000001b
                mov     rcnty, al
                pop     ax
                shr     al, 1
                and     al, 00000111b
                mov     rcntx, al

                xor     ax, ax
                mov     al, rcntx
                mov     cx, 100h
                mul     cx
                push    ax
                xor     ax, ax
                mov     al, rcnty
                mov     cx, 40h
                mul     cx
                inc     ax
                pop     dx
                add     ax, dx

                mov     cx, 0ah
                lea     si, [rfhcntASC]
                call    IntToAsc
                
                pop     si
                pop     di
                pop     dx
                pop     cx
                pop     bx
                pop     ax
                ret

GetInfo         endp

RWSysPLLVal     proc    near
                local   RWReg:byte

                mov     RWReg, al

.IF	(PCIBIOS == 0)
.386c
                push    edx
                mov     eax, devFuncBus
                shl     eax, 8
                mov     edx, MGA_INDEX1
                shr     edx, 2
                shl     edx, 2
                add     eax, edx
                or      eax, 80000000h
                mov     edx, CONFADD
                out     dx, eax
                jmp     $+2
                jmp     $+2

                mov     eax, PALWTADD
                mov     edx, CONFDATA
                out     dx, eax
                jmp     $+2
                jmp     $+2

                mov     eax, devFuncBus
                shl     eax, 8
                mov     edx, MGA_DATA1
                shr     edx, 2
                shl     edx, 2
                add     eax, edx
                or      eax, 80000000h
                mov     edx, CONFADD
                out     dx, eax
                jmp     $+2
                jmp     $+2

                mov     edx, CONFDATA
                in      eax, dx

                and     eax, 00FFFF00h
                mov     dl, [bp+4]
                shl     edx, 24
                mov     dl, [bp+4]
                add     eax, edx
                mov     edx, CONFDATA
                out     dx, eax
                jmp     $+2
                jmp     $+2

                mov     eax, devFuncBus
                shl     eax, 8
                mov     edx, MGA_INDEX1
                shr     edx, 2
                shl     edx, 2
                add     eax, edx
                or      eax, 80000000h
                mov     edx, CONFADD
                out     dx, eax
                jmp     $+2
                jmp     $+2

                mov     eax, X_DATAREG
                mov     edx, CONFDATA
                out     dx, eax
                jmp     $+2
                jmp     $+2

                mov     eax, devFuncBus
                shl     eax, 8
                mov     edx, MGA_DATA1
                shr     edx, 2
                shl     edx, 2
                add     eax, edx
                or      eax, 80000000h
                mov     edx, CONFADD
                out     dx, eax
                jmp     $+2
                jmp     $+2

                
                mov	edx, CONFDATA

                .IF 	(RWReg == 0)
                in      eax, dx
                shr     eax, 16
                .ENDIF

                .IF	(RWReg == 1)
                xor	eax, eax
                mov	al, [bp+6]
                shl	eax, 16
                out	dx, eax
                jmp     $+2
                jmp     $+2
                .ENDIF

                pop     edx
.ENDIF

.286c

.IF	(PCIBIOS == 1)
                push    bx
                push    cx
                push    dx
                push    di
                
                mov     ax, WCONF_W
                mov     bx, word ptr [devFuncBus]
                mov     di, MGA_INDEX1
                mov     cx, PALWTADD
                int     1ah

                mov     ax, WCONF_B
                mov     di, MGA_DATA1
                mov     cl, [bp+4]
                int     1ah
                                           
                mov     ax, WCONF_W
                mov     di, MGA_INDEX1
                mov     cx, X_DATAREG
                int     1ah

                .IF     ( RWReg == 0)
                mov     ax, RCONF_B
                mov     di, MGA_DATA2
                int     1ah
                mov	al, cl
                .ENDIF

                .IF     ( RWReg == 1)
                mov     ax, WCONF_B
                mov     di, MGA_DATA2
                mov     cl, [bp+6]
                int     1ah
                .ENDIF

                                
                pop     di
                pop     dx
                pop     cx
                pop     bx
.ENDIF
                ret

RWSysPLLVal     endp



WriteMemWait    proc    near

                push    bp
                mov     bp, sp

                mov     al, [bp+8h]
                .IF     ( al > 1 || al < 0 )
                mov     ax, 0ffffh
                pop     bp
                ret
                .ENDIF

                mov     al, [bp+6]
                .IF     ( al > 1 || al < 0 )
                mov     ax, 0ffffh
                pop     bp
                ret
                .ENDIF

                mov     al, [bp+4]
                .IF     ( al > 3 || al < 0 )
                mov     ax, 0ffffh
                pop     bp
                ret
                .ENDIF
                
                push	ax
                push    bx
                push    cx
                push	dx
                push    di
                push	si

                xor     ax, ax
                mov     al, [bp+8h]      ; CASlan
                add     al, 2
                mov     cx, 0ah
                lea     si, sCSlanASC
                call    IntToASC

                xor     ax, ax
                mov     al, [bp+6]      ; RCDelay
                add     al, 2
                mov     cx, 0ah
                lea     si, sRCDelayASC
                call    IntToASC

                xor     ax, ax
                mov     al, [bp+4]      ; RMAct
                add     al, 4
                mov     cx, 0ah
                lea     si, sRMActASC
                call    IntToASC

.IF	(PCIBIOS == 0)
.386c
                push    eax
                push    edx
                       
                mov     eax, devFuncBus
                shl     eax, 8
                mov     edx, MGA_INDEX1
                shr     edx, 2
                shl     edx, 2
                add     eax, edx
                or      eax, 80000000h
                mov     edx, CONFADD
                out     dx, eax
                jmp     $+2
                jmp     $+2

                mov     edx, CONFDATA
                mov     eax, SEQ
                out     dx, eax
                jmp     $+2
                jmp     $+2


                mov     eax, devFuncBus
                shl     eax, 8
                mov     edx, MGA_DATA1
                shr     edx, 2
                shl     edx, 2
                add     eax, edx
                or      eax, 80000000h
                mov     edx, CONFADD
                out     dx, eax
                jmp     $+2
                jmp     $+2

                mov     edx, CONFDATA
                in      eax, dx
                mov     al, CLKMODE
                out     dx, eax
                jmp     $+2
                jmp     $+2

                
                in      eax, dx
                or      eax, 00000000000000000010000000000000b
                out     dx, eax
                jmp     $+2
                jmp     $+2

;---------------------------------------------------------
.386c
                mov     eax, devFuncBus
                shl     eax, 8
                mov     edx, MGA_INDEX1
                shr     edx, 2
                shl     edx, 2
                add     eax, edx
                or      eax, 80000000h
                mov     edx, CONFADD
                out     dx, eax
                jmp     $+2
                jmp     $+2

                mov     eax, MCTLWTST
                mov     edx, CONFDATA
                out     dx, eax
                jmp     $+2
                jmp     $+2


                mov     eax, devFuncBus
                shl     eax, 8
                mov     edx, MGA_DATA1
                shr     edx, 2
                shl     edx, 2
                add     eax, edx
                or      eax, 80000000h
                mov     edx, CONFADD
                out     dx, eax
                jmp     $+2
                jmp     $+2


		xor	eax, eax
                mov     al, [bp+4h]
		shl	eax, 8
                add     al, [bp+6h]
		shl	eax, 8
                add     al, [bp+8h]

                mov	edx, CONFDATA
                out	dx, eax
                jmp     $+2
                jmp     $+2
.286c
                call    memReset

;---------------------------------------------------------
.386c
                mov     eax, devFuncBus
                shl     eax, 8
                mov     edx, MGA_INDEX1
                shr     edx, 2
                shl     edx, 2
                add     eax, edx
                or      eax, 80000000h
                mov     edx, CONFADD
                out     dx, eax
                jmp     $+2
                jmp     $+2

                mov     edx, CONFDATA
                mov     eax, SEQ
                out     dx, eax
                jmp     $+2
                jmp     $+2

                mov     eax, devFuncBus
                shl     eax, 8
                mov     edx, MGA_DATA1
                shr     edx, 2
                shl     edx, 2
                add     eax, edx
                or      eax, 80000000h
                mov     edx, CONFADD
                out     dx, eax
                jmp     $+2
                jmp     $+2

                mov     edx, CONFDATA
                in      eax, dx
                mov     al, CLKMODE
                out     dx, eax
                jmp     $+2
                jmp     $+2
               
                in      eax, dx
                and     eax, 11111111111111111101111111111111b
                out     dx, eax
                jmp     $+2
                jmp     $+2

                pop     edx
                pop     eax
.ENDIF

.286c

.IF	(PCIBIOS == 1)

                mov     ax, WCONF_W
                mov     bx, word ptr [devFuncBus]
                mov     di, MGA_INDEX1
                mov     cx, SEQ
                int     1ah

                mov     ax, WCONF_B
                mov     di, MGA_DATA1
                mov     cl, CLKMODE
                int     1ah

                mov     ax, RCONF_B
                mov     di, MGA_DATA1+1
                int     1ah
                or      cl, 00100000b
                mov     ax, WCONF_B
                int     1ah
;---------------------------------------------------------
                mov     ax, WCONF_W
                mov     bx, word ptr [devFuncBus]
                mov     di, MGA_INDEX1
                mov     cx, MCTLWTST
                int     1ah
.386c
		push	eax
		push	ecx

		xor	eax, eax
                mov     al, [bp+4h]
		shl	eax, 8
                add     al, [bp+6h]
		shl	eax, 8
                add     al, [bp+8h]
		mov	ecx, eax
.286c

                mov     ax, WCONF_D             
                mov     di, MGA_DATA1
                int     1ah

                call    memReset

.386c
                pop     ecx
		pop	eax
.286c

;---------------------------------------------------------

                mov     ax, WCONF_W
                mov     bx, word ptr [devFuncBus]
                mov     di, MGA_INDEX1
                mov     cx, SEQ
                int     1ah


                mov     ax, WCONF_B
                mov     di, MGA_DATA1
                mov     cl, CLKMODE
                int     1ah

                mov     ax, RCONF_B
                mov     di, MGA_DATA1+1
                int     1ah
                and     cl, 11011111b
                mov     ax, WCONF_B
                int     1ah
.ENDIF

                mov     ah, 09h
                lea     dx, [setMemWaitMsg]
                int     21h
                

                pop     si
                pop     di
                pop     dx
                pop     cx
                pop     bx
                pop     ax

                pop     bp
                ret

WriteMemWait    endp

RWRfCTR         proc    near            ; rcntx, rcnty
                local   RWReg:byte
                mov     RWReg, al

.IF	(PCIBIOS == 0)

                .IF     (RWReg == 0)
.386c
                mov     eax, devFuncBus
                shl     eax, 8
                mov     edx, MGA_OPTION
                shr     edx, 2
                shl     edx, 2
                add     eax, edx
                or      eax, 80000000h
                mov     edx, CONFADD
                out     dx, eax
                jmp     $+2
                jmp     $+2

                mov     edx, CONFDATA
                in      eax, dx
                shr     eax, 16
.286c
                .ENDIF


                .IF      (RWReg == 1)

                mov     al, [bp+6]
                .IF     ( al > 7 || al < 0)
                mov     ax, 0ffffh
                ret
                .ENDIF

                mov     al, [bp+4]
                .IF     ( al > 1 || al < 0)
                mov     ax, 0ffffh
                ret
                .ENDIF
                
                xor     ax, ax
                mov     al, rcntx
                mov     cx, 100h
                mul     cx
                push    ax
                xor     ax, ax
                mov     al, rcnty
                mov     cx, 40h
                mul     cx
                inc     ax
                pop     dx
                add     ax, dx

                mov     cx, 0ah
                lea     si, [oldrfcnt]
                call    IntToAsc

                xor     ax, ax
                mov     al, [bp+6]
                mov     cx, 100h
                mul     cx
                push    ax
                xor     ax, ax
                mov     al, [bp+4]
                mov     cx, 40h
                mul     cx
                inc     ax
                pop     dx
                add     ax, dx

                mov     cx, 0ah
                lea     si, [newrfcnt]
                call    IntToAsc

.386c                
                xor     ecx, ecx
                mov     cl, [bp+6]
                shl     cl, 1
                add     cl, [bp+4]
                shl     ecx, 16

                mov     eax, devFuncBus
                shl     eax, 8
                mov     edx, MGA_OPTION
                shr     edx, 2
                shl     edx, 2
                add     eax, edx
                or      eax, 80000000h
                mov     edx, CONFADD
                out     dx, eax
                jmp     $+2
                jmp     $+2

                mov     edx, CONFDATA
                in      eax, dx
                and     eax, 11111111111100001111111111111111b
                add     eax, ecx
                out     dx, eax
                jmp     $+2
                jmp     $+2
.286c
                mov     ah, 09h
                lea     dx, [sRfcnt]
                int     21h
                .ENDIF
.ENDIF

.IF	(PCIBIOS == 1)
                .IF     (RWReg == 0)
                mov     ax, RCONF_B
                mov     bx, word ptr [devFuncBus]
                mov     di, MGA_OPTION+2
                int     1ah
                mov	al, cl
                .ENDIF

                .IF      (RWReg == 1)

                mov     al, [bp+6]
                .IF     ( al > 7 || al < 0)
                mov     ax, 0ffffh
                ret
                .ENDIF

                mov     al, [bp+4]
                .IF     ( al > 1 || al < 0)
                mov     ax, 0ffffh
                ret
                .ENDIF


                xor     ax, ax
                mov     al, rcntx
                mov     cx, 100h
                mul     cx
                push    ax
                xor     ax, ax
                mov     al, rcnty
                mov     cx, 40h
                mul     cx
                inc     ax
                pop     dx
                add     ax, dx

                mov     cx, 0ah
                lea     si, [oldrfcnt]
                call    IntToAsc

                xor     ax, ax
                mov     al, [bp+6]
                mov     cx, 100h
                mul     cx
                push    ax
                xor     ax, ax
                mov     al, [bp+4]
                mov     cx, 40h
                mul     cx
                inc     ax
                pop     dx
                add     ax, dx

                mov     cx, 0ah
                lea     si, [newrfcnt]
                call    IntToAsc
                
                xor     cx, cx
                mov     cl, [bp+6]
                shl     cl, 1
                add     cl, [bp+4]
                
                mov     ax, WCONF_B
                mov     bx, word ptr [devFuncBus]
                mov     di, MGA_OPTION+2
                int     1ah

                mov     ah, 09h
                lea     dx, [sRfcnt]
                int     21h
                .ENDIF
.ENDIF
                ret

RWRfCTR         endp



RWClkDiv        proc    near
                local   RWReg:byte
                mov     RWreg, al

.IF	(PCIBIOS == 0)
                .IF     ( RWReg == 0 )
.386c
                mov     eax, devFuncBus
                shl     eax, 8
                mov     edx, MGA_OPTION
                shr     edx, 2
                shl     edx, 2
                add     eax, edx
                or      eax, 80000000h
                mov     edx, CONFADD
                out     dx, eax
                jmp     $+2
                jmp     $+2

                mov     edx, CONFDATA
                in      eax, dx
                shr     eax, 3
                and     eax, 00000000000000000000000000000011b
                mov     ecx, eax
.286c
                push    ax
                and     ax, 1
                pop     cx
                push    ax
                mov     ax, cx

                shr     al, 1
                and     ax, 1
                shl     ax, 8
                pop     cx
                add     ax, cx
                .ENDIF
                
                .IF     ( RWReg == 1)

                mov     al, [bp+6]
                .IF     ( al < 0 || al > 1)
                mov     ax, 0ffffh
                ret
                .ENDIF
                
                mov     al, [bp+4]
                .IF     ( al < 0 || al > 1)
                mov     ax, 0ffffh
                ret
                .ENDIF


                .IF     (gclkDiv == 0)
                mov     oldgdivASC, '3'
                .ELSE
                mov     oldgdivASC, '1'
                .ENDIF
                                
                .IF     (mclkDiv == 0)
                mov     oldmdivASC, '2'
                .ELSE
                mov     oldmdivASC, '1'
                .ENDIF

                mov     al, [bp+6]
                mov     ah, [bp+4]

                .IF     ( al == 0)
                mov     newgdivASC, '3'
                .ELSE
                mov     newgdivASC, '1'
                .ENDIF
                                
                .IF     ( ah == 0)
                mov     newmdivASC, '2'
                .ELSE
                mov     newmdivASC, '1'
                .ENDIF
.386c
                mov     eax, devFuncBus
                shl     eax, 8
                mov     edx, MGA_OPTION
                shr     edx, 2
                shl     edx, 2
                add     eax, edx
                or      eax, 80000000h
                mov     edx, CONFADD
                out     dx, eax
                jmp     $+2
                jmp     $+2

                mov     edx, CONFDATA
                in      eax, dx
                or      al, 00000100b
                out     dx, eax
                jmp     $+2
                jmp     $+2

                in      eax, dx
                
                mov     cl, [bp+4]      ; MCLK

                .IF     ( cl == 1 )
                shl     cl, 4
                or      al, cl
                .ELSEIF ( cl == 0 )
                mov     cl, 1
                shl     cl, 4
                not     cl
                and     al, cl
                .ENDIF

                mov     cl, [bp+6]      ; GCLK
                .IF     ( cl == 1 )
                shl     cl, 3
                or      al, cl
                .ELSEIF ( cl == 0 )
                mov     cl, 1
                shl     cl, 3
                not     cl
                and     al, cl
                .ENDIF

                out     dx, eax
                jmp     $+2
                jmp     $+2

                in      eax, dx
                and     al, 11111011b
                out     dx, eax
                jmp     $+2
                jmp     $+2

.286c
                mov     ah, 09h
                lea     dx, [setClkDivMsg]
                int     21h
                .ENDIF
.ENDIF

.IF	(PCIBIOS == 1)
                .IF     ( RWReg == 0 )
                mov     ax, RCONF_B
                mov     bx, word ptr [devFuncBus]
                mov     di, MGA_OPTION
                int     1ah
                shr     cl, 3
                push    cx
                and     cx, 1
                pop     ax
                push    cx
                mov     cx, ax

                shr     cl, 1
                and     cx, 1
                shl     cx, 8
                pop     ax
                add     cx, ax
		mov	ax, cx
                .ENDIF
                
                .IF     ( RWReg == 1)

                mov     al, [bp+6]
                .IF     ( al < 0 || al > 1)
                mov     ax, 0ffffh
                ret
                .ENDIF
                
                mov     al, [bp+4]
                .IF     ( al < 0 || al > 1)
                mov     ax, 0ffffh
                ret
                .ENDIF


                .IF     (gclkDiv == 0)
                mov     oldgdivASC, '3'
                .ELSE
                mov     oldgdivASC, '1'
                .ENDIF
                                
                .IF     (mclkDiv == 0)
                mov     oldmdivASC, '2'
                .ELSE
                mov     oldmdivASC, '1'
                .ENDIF

                mov     al, [bp+6]
                mov     ah, [bp+4]

                .IF     ( al == 0)
                mov     newgdivASC, '3'
                .ELSE
                mov     newgdivASC, '1'
                .ENDIF
                                
                .IF     ( ah == 0)
                mov     newmdivASC, '2'
                .ELSE
                mov     newmdivASC, '1'
                .ENDIF
                
                mov     ax, RCONF_B
                mov     bx, word ptr [devFuncBus]
                mov     di, MGA_OPTION
                int     1ah

                or      cl, 00000100b
                mov     ax, WCONF_B
                int     1ah

                mov     ax, RCONF_B
                mov     bx, word ptr [devFuncBus]
                mov     di, MGA_OPTION
                int     1ah
                
                mov     al, [bp+4]      ; MCLK
                .IF     ( al == 1 )
                shl     al, 4
                or      cl, al
                .ELSEIF ( al == 0 )
                mov     al, 1
                shl     al, 4
                not     al
                and     cl, al
                .ENDIF

                mov     al, [bp+6]      ; GCLK
                .IF     ( al == 1 )
                shl     al, 3
                or      cl, al
                .ELSEIF ( al == 0 )
                mov     al, 1
                shl     al, 3
                not     al
                and     cl, al
                .ENDIF
                mov     ax, WCONF_B
                int     1ah

                mov     ax, RCONF_B
                mov     bx, word ptr [devFuncBus]
                mov     di, MGA_OPTION
                int     1ah
                
                and     cl, 11111011b
                mov     ax, WCONF_B
                int     1ah

                mov     ah, 09h
                lea     dx, [setClkDivMsg]
                int     21h
                .ENDIF
.ENDIF
                ret

RWClkDiv        endp


SetSysPLLVal    proc    near

                push    bp
                mov     bp, sp

                mov     al, [bp+8]
                .IF     ( al < 1 || al > 31)
                mov     ax, 0ffffh
                pop     bp
                ret
                .ENDIF

                mov     al, [bp+6]
                .IF     ( al < 1 || al > 127)
                mov     ax, 0ffffh
                pop     bp
                ret
                .ENDIF

                mov     al, [bp+4]
                .IF     !( al == 0 || al == 1 || al == 3 || al == 7)
                mov     ax, 0ffffh
                pop     bp
                ret
                .ENDIF


                xor     ax, ax
                mov     al, m_val
                push    ax
                mov     al, n_val
                push    ax
                mov     al, p_val
                push    ax
                call    CalcFreq
                add     sp, 6

                lea     si, oldClkqASC
                call    IntToAsc
                mov     ax, dx
                lea     si, oldClkrASC
                call    IntToAsc


                push    [bp+8]          ; M Value
                push    [bp+6]          ; N Value
                push    [bp+4]          ; P Value
                call    CalcFreq
                add     sp, 6

                .IF     ( ax < 100 )
                mov     s_Val, 0

                .ELSEIF ( ax >= 100 && ax < 140 )
                mov     s_Val, 1

                .ELSEIF ( ax >= 140 && ax < 180 )
                mov     s_Val, 2

                .ELSEIF ( ax >= 180 )
                mov     s_Val, 3
                .ENDIF

                lea     si, newClkqASC
                call    IntToAsc
                mov     ax, dx
                lea     si, newClkrASC
                call    IntToAsc

.IF	(PCIBIOS == 0)                
.386c
                mov     eax, devFuncBus
                shl     eax, 8
                mov     edx, MGA_OPTION
                shr     edx, 2
                shl     edx, 2
                add     eax, edx
                or      eax, 80000000h
                mov     edx, CONFADD
                out     dx, eax
                jmp     $+2
                jmp     $+2


                mov     edx, CONFDATA
                in      eax, dx

                or      al, 00000100b
                out	dx, eax
                jmp     $+2
                jmp     $+2


                and     al, 11111100b
                out	dx, eax
                jmp     $+2
                jmp     $+2



                and     al, 11111011b
                out	dx, eax
                jmp     $+2
                jmp     $+2
.ENDIF

.286c

.IF	(PCIBIOS == 1)
                mov     ax, RCONF_B
                mov     bx, word ptr [devFuncBus]
                mov     di, MGA_OPTION
                int     1ah

                or      cl, 00000100b
                mov     ax, WCONF_B
                int     1ah

                and     cl, 11111100b
                mov     ax, WCONF_B
                int     1ah

                and     cl, 11111011b
                mov     ax, WCONF_B
                int     1ah
.ENDIF
                push    [bp+8]
                push    SYSPLL_M
                mov     al, 1
                call    RWSysPLLVal
                add     sp, 4

                push    [bp+6]
                push    SYSPLL_N
                mov     al, 1
                call    RWSysPLLVal
                add     sp, 4

                xor     ax, ax
                mov     al, s_Val
                shl     al, 3
                add     al, [bp+4]
                push    ax
                push    SYSPLL_P
                mov     al, 1
                call    RWSysPLLVal
                add     sp, 4

                .REPEAT
                push    SYSPLLSTAT
                xor     al, al
                call    RWSysPLLVal
                add     sp, 2
                and     al, 01000000b
                .UNTIL ( al == 01000000b )

.IF 	(PCIBIOS == 0)
.386c
                mov     eax, devFuncBus
                shl     eax, 8
                mov     edx, MGA_OPTION
                shr     edx, 2
                shl     edx, 2
                add     eax, edx
                or      eax, 80000000h
                mov     edx, CONFADD
                out     dx, eax
                jmp     $+2
                jmp     $+2

                mov     edx, CONFDATA
                in      eax, dx

                or      al, 00000100b
                out	dx, eax
                jmp     $+2
                jmp     $+2

                or      al, 00000001b
                and     al, 11111101b
                out	dx, eax
                jmp     $+2
                jmp     $+2


                and     al, 11111011b
                out	dx, eax
                jmp     $+2
                jmp     $+2
.ENDIF

.286c

.IF	(PCIBIOS == 1)
                mov     ax, RCONF_B
                mov     bx, word ptr [devFuncBus]
                mov     di, MGA_OPTION
                int     1ah

                or      cl, 00000100b
                mov     ax, WCONF_B
                int     1ah

                or      cl, 00000001b
                and     cl, 11111101b
                mov     ax, WCONF_B
                int     1ah

                and     cl, 11111011b
                mov     ax, WCONF_B
                int     1ah
.ENDIF
                mov     ah, 09h
                lea     dx, [setClkMsg]
                int     21h
                                              
                pop     bp
                ret

SetSysPLLVal    endp


CalcFreq        proc    near          ; M,N,P

                push    bp
                mov     bp, sp
                push    cx
                xor     cx, cx

                mov     ax, 1432
                mov     cl, [bp+6h]     ; N Value
                inc     cl
                mul     cx
                push    ax
                push    dx

                mov     al, [bp+8h]     ; M Value
                inc     al
                mov     cl, [bp+4h]     ; P Value
                inc     cl
                mul     cl
                mov     cx, ax
                pop     dx
                pop     ax
                div     cx

                xor     dx, dx
                mov     cx, 100
                div     cx

                pop     cx
                pop     bp
                ret

CalcFreq        endp

memReset        proc    near
                local   colorDepth:byte

                push    ax
                push    bx
                push    cx
                push    di

                push    XMULCTRL
                xor     al, al
                call    RWSysPLLVal
                add     sp, 2
                and     al, 00000111b
                mov     colorDepth, al

.IF	(PCIBIOS == 0)
.386c
                push    eax
                push    ecx
                push    edx

                mov     eax, devFuncBus
                shl     eax, 8
                mov     edx, MGA_OPTION
                shr     edx, 2
                shl     edx, 2
                add     eax, edx
                or      eax, 80000000h
                mov     edx, CONFADD
                out     dx, eax
                jmp     $+2
                jmp     $+2


                mov     edx, CONFDATA
                in      eax, dx
                and     eax, 11111111111111111110111111111111b  ;memconfig(0)
                out     dx, eax
                jmp     $+2
                jmp     $+2
.286c
		call	Wait_sub
.386c
                mov     eax, devFuncBus
                shl     eax, 8
                mov     edx, MGA_INDEX1
                shr     edx, 2
                shl     edx, 2
                add     eax, edx
                or      eax, 80000000h
                mov     edx, CONFADD
                out     dx, eax
                jmp     $+2
                jmp     $+2

                mov     eax, MACCESS
                mov     edx, CONFDATA
                out     dx, eax
                jmp     $+2
                jmp     $+2

                mov     eax, devFuncBus
                shl     eax, 8
                mov     edx, MGA_DATA1
                shr     edx, 2
                shl     edx, 2
                add     eax, edx
                or      eax, 80000000h
                mov     edx, CONFADD
                out     dx, eax
                jmp     $+2
                jmp     $+2

                mov     al, colorDepth

                .IF     (al == 000b || al == 101b)          ; 8-bit
                xor     al, al
                .ELSEIF     (al == 010b)                    ; 16-bit
                mov     al, 1
                .ELSEIF     (al == 011b)                    ; 24-bit
                mov     al, 3
                .ELSEIF     (al == 100b || al == 111b)      ; 32-bit
                mov     al, 2
                .ENDIF

                mov     ecx, 00000000000000001000000000000000b
                add     cl, al
                mov     eax, ecx

                mov     edx, CONFDATA
                out     dx, eax       ; MACESS memreset(1), jedecrst(0)
                jmp     $+2
                jmp     $+2
.286c
		call	Wait_sub

                mov     al, colorDepth
                .IF     (al == 000b || al == 101b)      ; 8-bit
                xor     al, al
                .ELSEIF     (al == 010b)                ; 16-bit
                mov     al, 1
                .ELSEIF     (al == 011b)                ; 24-bit
                mov     al, 3
                .ELSEIF     (al == 100b || al == 111b)  ; 32-bit
                mov     al, 2
                .ENDIF

.386c
                mov     ecx, 00000000000000001100000000000000b
                add     cl, al
                mov     eax, ecx

                out     dx, eax       ; MACESS memreset(1), jedecrst(1)
                jmp     $+2
                jmp     $+2


                pop     edx
                pop     ecx
                pop     eax
.ENDIF
.286c

.IF	(PCIBIOS == 1)

                mov     ax, RCONF_B
                mov     bx, word ptr [devFuncBus]
                mov     di, MGA_OPTION+1
                int     1ah
                and     cl, 11101111b   ;memconfig(0)
                mov     ax, WCONF_B
                int     1ah
                
		call 	Wait_sub

                mov     ax, WCONF_W
                mov     bx, word ptr [devFuncBus]
                mov     di, MGA_INDEX1
                mov     cx, MACCESS
                int     1ah

                mov     al, colorDepth
                .IF     (al == 000b || al == 101b)          ; 8-bit
                xor     al, al
                .ELSEIF     (al == 010b)                    ; 16-bit
                mov     al, 1
                .ELSEIF     (al == 011b)                    ; 24-bit
                mov     al, 3
                .ELSEIF     (al == 100b || al == 111b)      ; 32-bit
                mov     al, 2
                .ENDIF
.386c
                mov     ecx, 00000000000000001000000000000000b
                add     cl, al
.286c

                mov     ax, WCONF_D       ; MACESS memreset(1), jedecrst(0)
                mov     di, MGA_DATA1
                int     1ah

		call	Wait_sub

                mov     al, colorDepth
                .IF     (al == 000b || al == 101b)      ; 8-bit
                xor     al, al
                .ELSEIF     (al == 010b)                ; 16-bit
                mov     al, 1
                .ELSEIF     (al == 011b)                ; 24-bit
                mov     al, 3
                .ELSEIF     (al == 100b || al == 111b)  ; 32-bit
                mov     al, 2
                .ENDIF
.386c
                mov     ecx, 00000000000000001100000000000000b
                add     cl, al
.286c
                mov     ax, WCONF_D       ; MACESS memreset(1), jedecrst(1)
                mov     bx, word ptr [devFuncBus]
                mov     di, MGA_DATA1
                int     1ah
.ENDIF
.286c
                pop     di
                pop     cx
                pop     bx
                pop     ax

                ret

memReset        endp

Wait_sub	proc

                push    ds
                mov     ax, 0040h
                mov     ds, ax
                mov     al, ds:[006ch]
                mov     cl, al
                .REPEAT
                mov     al, ds:[006ch]    ; Wait
                .UNTIL  (al != cl)
                pop     ds

                ret

Wait_sub	endp


include <E:\INT-ASC.INC>
include <E:\ASC-INT.INC>


devFuncBus      dd      0
m_Val           db      0
n_Val           db      0
p_Val           db      0
s_Val           db      0
rcntx           db      0
rcnty           db      0
gclkDiv         db      0
mclkDiv         db      0
resCmd          db      0
noParam         db      1
PCIBIOS         db      1

INIFile         db      'MYSTCLK.INI',0
workBuffer      db      10 dup (0)
INIString       db      'PCIBIOS='

HeaderMsg       db      0dh,0ah,
                        'Matrox MGA Myst/Myst220/G100/G200 GCLK/MCLK Programmer',0dh,0ah,
                        'Version 0.33 Beta Release.        All rights reserved.',0dh,0ah
PCIAccess       db      'Using ','$'

PCIBIOSCall     db      'Intel PCI BIOS (Interrupt 1Ah).',0dh,0ah,0dh,0ah,'$'
PCIMech1        db      'PCI Configuration Mechanism 1.',0dh,0ah,0dh,0ah,'$'

ChipInfo        db      'Chipset: ','$'
MystPCI         db      'Matrox MGA-1064SG/1164SG',0dh,0ah,0dh,0ah,'$'
G100PCI         db      'Matrox MGA-G100 PCI',0dh,0ah,0dh,0ah,'$'
G100AGP         db      'Matrox MGA-G100 AGP',0dh,0ah,0dh,0ah,'$'
G200PCI         db      'Matrox MGA-G200 PCI',0dh,0ah,0dh,0ah,'$'
G200AGP         db      'Matrox MGA-G200 AGP',0dh,0ah,0dh,0ah,'$'

ShowMsg         db      '       System PLL Parameter:',0dh,0ah,0dh,0ah,
                        '           M = ',3 dup (20h)
M_ASC           db      20h,0dh,0ah,'           N = ',3 dup (20h)
N_ASC           db      20h,0dh,0ah,'           P = ',3 dup (20h)
P_ASC           db      20h,0dh,0ah,0dh,0ah,
                        '       System PLL clock (Fo) = ',20h,20h
FreqASCq        db      20h,'.','0'
FreqASCr        db      '0','MHz',0dh,0ah,0dh,0ah,
                        '       RAM Refresh Counter = ',20h,20h,20h
rfhcntASC       db      20h,' MCLK',0dh,0ah,0dh,0ah,
                        '       Clock Divider: GCLK = Fo/'
gdivASC         db      20h,0dh,0ah,
                        '                      MCLK = Fo/'
mdivASC         db      20h,0dh,0ah,0dh,0ah,
                        '       Use "/?" to see available options.',
                        0dh,0ah,'$'

setClkMsg       db      '       Old system PLL clock (Fo) = ',20h,20h
oldClkqASC      db      20h,'.','0'
oldClkrASC      db      '0','MHz', 0dh,0ah,
                        '       New system PLL clock <Fo) = ',20h,20h
newClkqASC      db      20h,'.','0'
newClkrASC      db      '0','MHz', 0dh,0ah,0dh,0ah,'$'

setMemWaitMsg   db      '       CAS Latency         = '
sCSlanASC       db      20h,' MCLK',0dh,0ah,
                        '       RAS-to-CAS Delay    = '
sRCDelayASC     db      20h,' MCLK',0dh,0ah,
                        '       RAS Min Active Time = '
sRMActASC       db      20h,' MCLK',0dh,0ah,0dh,0ah, '$'

sRfcnt          db      '       Old RAM Refresh Counter = ',20h,20h,20h
oldrfcnt        db      20h,' MCLK',0dh,0ah,
                        '       New RAM Refresh Counter = ',20h,20h,20h
newrfcnt        db      20h,' MCLK',0dh,0ah,0dh,0ah,'$'

setClkDivMsg    db      '       Old Clock Divider: GCLK = Fo/'
oldgDivASC      db      20h,0dh,0ah,
                        '                          MCLK = Fo/'
oldmDivASC      db      20h,0dh,0ah,
                        '       New Clock Divider: GCLK = Fo/'
newgDivASC      db      20h,0dh,0ah,
                        '                          MCLK = Fo/'
newmDivASC      db      20h,0dh,0ah,0dh,0ah, '$'

Hlp    db 'Syntax:    MYSTCLK.COM [options]',0dh,0ah,0dh,0ah,
          'If options field is omitted, MYSTCLK will show',0dh,0ah,
          'the content of Mystique timings registers.',0dh,0ah,0dh,0ah
hlp1   db 'Available options:- ',0dh,0ah,0dh,0ah,
          '  /1 m n p   - change the content of M, N and P registers ',0dh,0ah,
          '               of system PLL to the value specified by m,n,p. ',0dh,0ah,
          '               The valid values for m,n,p are: ',0dh,0ah,0dh,0ah

hlp2   db '                     1 <= m <=  31 ',0dh,0ah,
          '                     1 <= n <= 127 ',0dh,0ah,
          '                     p = 0,1,3,7 ',0dh,0ah,0dh,0ah

hlp2a  db '             The formula for system PLL clock is: ',0dh,0ah,0dh,0ah,
          '                              ( N + 1 ) ',0dh,0ah,
          ' System PLL Clock (Fo) = ------------------ * 14.31818MHz ',0dh,0ah,
          '                         ( M + 1 ) ( P + 1) ',0dh,0ah,'$'

hlp3   db '  /2 a b c - SGRAM optimization.',0dh,0ah,
          '             a - CAS Latency      ( 0 = 2 MCLK, 1 = 3 MCLK ) ',0dh,0ah,
          '             b - RAS-to-CAS Delay ( 0 = 2 MCLK, 1 = 3 MCLK ) ',0dh,0ah
hlp3a  db '             c - RAS Minimum Active Time ( 0 = 4 MCLK, 1 = 5 MCLK',0dh,0ah,
          '                                           2 = 6 MCLK, 3 = 7 MCLK )',0dh,0ah,
          0dh,0ah,0dh,0ah

hlp4   db '  /3 G M - Graphic Clock Divider and Memory Clock Devider ',0dh,0ah,
          '           Graphics clock, G ( 0 = /3, 1 = /1 ) ',0dh,0ah,
          '           Memory   clock, M ( 0 = /2, 1 = /1 ) ',0dh,0ah,0dh,0ah

warn   db '         ***** CAUTION WHEN CHANGING CLOCK DIVIDER !!! ***** ',0dh,0ah,
          '           Make sure you lower the system PLL clock before  ',0dh,0ah,
          '           using a divider factor of 1. Or, you may risk of ',0dh,0ah,
          '           damaging your display card.',0dh,0ah,0dh,0ah

hlp5   db '  /4 x y - RAM Refresh Counter. Setting x and y to 0 halts memory refresh.',0dh,0ah,       
          '           RAM Refresh period = (( x * 256 ) + ( y * 64 ) + 1) MCLK',0dh,0ah,
          '           where 0 <= x <= 7 and 0 <= y <= 1.',0dh,0ah,0dh,0ah
msgaut db '    Mystique GCLK/MCLK Programmer is dedicated to all computer.',0dh,0ah,
          '    hardware enthusiasts. No fee should be charged on its use. ',0dh,0ah,0dh,0ah,
          '                                 K.J.Liew <kjliew@pop.jaring.my>','$'

Err1NoPCI       db      'Not a PCI system.',0dh,0ah,0dh,0ah,'$'
Err2NoMGA       db      'Cannot find Matrox MGA display adapter.',
                         0dh,0ah,0dh,0ah, '$'
Err3Param       db      'Invalid input values detected.',0dh,0ah,
                        'Please use "/?" for proper input value.',
                        0dh,0dh,0dh,0ah,'$'


prog            ends

                end     start

